/* OOP for Automation and Robotics
 * Winter 2011/12
 *
 * Solution to Excercise 7.3
 *
 * Carsten Gutwenger, 23.11.2011
 *
 */

#include <iostream>
#include <sstream>
//#include <string>
#include <map>
#include <vector>

#include "timespan.h"


using namespace std;


struct MP3Record
{
	string   title;   // title of the song
	string   album;   // album containing the song
	timespan length;  // length of the song
	int      year;    // year of publication

	MP3Record(string t, string a, const timespan &l, int y) : 
		title(t), album(a), length(l), year(y) { }
};


ostream &operator<<(ostream &os, const MP3Record &x)
{
	stringstream oss;
	oss << "{\n";
	oss << "  title:  " << x.title  << "\n";
	oss << "  album:  " << x.album  << "\n";
	oss << "  length: " << x.length << "\n";
	oss << "  year:   " << x.year   << "\n";
	oss << "}\n";
	os << oss.str();
	return os;
}


int main()
{
	// maps artist to a vector of mp3s by this artist
	map<string,vector<MP3Record> > collection;

	cout << "Enter command: l (lookup), i (insert), x (exit)" << endl;

	char c;
	string artist, title, album;
	timespan length;
	int year;

	do {
		cout << "Command: "; cin >> c;

		switch(c)
		{
		case 'l':
			{
				cout << "artist: "; cin >> artist;
				map<string,vector<MP3Record> >::iterator it = collection.find(artist);
				if(it == collection.end())
					cout << "no mp3s for <" << artist << "> found" << endl;
				else {
					const vector<MP3Record> &v = it->second;
					for(vector<MP3Record>::const_iterator iv = v.begin(); iv != v.end(); ++iv)
						cout << *iv << endl;
				}
			}
			break;

		case 'i':
			cout << "artist: "; cin >> artist;
			cout << "title:  "; cin >> title;
			cout << "album:  "; cin >> album;
			cout << "length: "; cin >> length;
			cout << "year:   "; cin >> year;

			collection[artist].push_back(MP3Record(title, album, length, year));
			break;

		case 'x':
			break;

		default:
			cout << "Unknown command \'" << c << "\'. Use l, i, x" << endl;
		}

	} while(c != 'x');

	return 0;
}
