/* OOP for Automation and Robotics
 * Winter 2011/12
 *
 * Solution to Excercise 7.3
 * Implementation of data type timespan (from Exercise 7.2)
 *
 * Carsten Gutwenger, 23.11.2011
 *
 */

#include "timespan.h"
#include <iomanip>
#include <sstream>


// equality operator
bool operator==(const timespan &t1, const timespan &t2)
{
	return (t1.hours == t2.hours && t1.minutes == t2.minutes && t1.seconds == t2.seconds);
}


// less-than operator
bool operator<(const timespan &t1, const timespan &t2)
{
	if(t1.hours < t2.hours)
		return true;

	if(t1.hours == t2.hours)
		return (t1.minutes * 60 + t1.seconds < t2.minutes * 60 + t2.seconds);

	return false;
}


// operator for adding two times
timespan operator+(const timespan &t1, const timespan &t2)
{
	timespan t;

	int sum_sec = t1.seconds + t2.seconds;
	t.seconds = sum_sec % 60;

	int sum_min = t1.minutes + t2.minutes + (sum_sec / 60);
	t.minutes = sum_min % 60;

	t.hours = t1.hours + t2.hours + (sum_min / 60);
	return t;
}


// output operator; format: hh:mm::ss
ostream &operator<<(ostream &os, const timespan &t)
{
	stringstream oss;
	oss << t.hours << ":" << setfill('0') << setw(2) << t.minutes << ":" << setw(2) << t.seconds;
	os << oss.str();
	return os;
}


// input operator; accepts timespans like "hh:mm:ss"
istream &operator>>(istream &is, timespan &t)
{
	int h = 0, m = 0, s = 0;
	char sep1 = '\0', sep2 = '\0';

	if(!(is >> h >> sep1 >> m >> sep2 >> s) || sep1 != ':' || sep2 != ':')
		is.setstate(cin.failbit);
	else
		t.assign(h,m,s);  // assignment function checks validity

	return is;
}
