/* OOP for Automation and Robotics
 * Winter 2011/12
 *
 * Solution to Excercise 7.3
 *
 * Header file for declaration of data type timespan from Exercise 7.2
 *
 * We provide all functionality for timespan as required in Ex. 7.2;
 * this is much more than what we need for solving this exercise!
 *
 * Carsten Gutwenger, 23.11.2011
 *
 */

#include <iostream>

using namespace std;


// data type time
struct timespan {
	int hours;
	int minutes; // 0-59
	int seconds; // 0-59

	timespan() : hours(0), minutes(0), seconds(0) { }

	timespan(int h, int m, int s) : hours(h), minutes(m), seconds(s) {
		truncate();
	}

	void assign(int h, int m, int s) {
		hours   = h;
		minutes = m;
		seconds = s;
		truncate();
	}

	void truncate() {
		if(hours < 0) hours = 0;
		if(minutes < 0) minutes = 0;
		if(seconds < 0) seconds = 0;

		if(seconds >= 60) {
			div_t ds = div(seconds,60);  // div computes quotient and remainder of seconds / 60
			seconds = ds.rem;
			minutes += ds.quot;
		}
		if(minutes >= 60) {
			div_t dm = div(minutes,60);
			minutes = dm.rem;
			hours += dm.quot;
		}
	}
};


// equality operator
bool operator==(const timespan &t1, const timespan &t2);

// less-than operator
bool operator<(const timespan &t1, const timespan &t2);


// operator for adding two times
timespan operator+(const timespan &t1, const timespan &t2);

// output operator; format: hh:mm::ss
ostream &operator<<(ostream &os, const timespan &t);

// input operator; accepts timespans like "hh:mm:ss"
istream &operator>>(istream &is, timespan &t);
